/////////////////////////////////////////////////////////////////////////////
// ZAboutDlg.cpp

#include "stdafx.h"
#include "App.h"
#include "ZAboutDlg.h"
#include "FavoriteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ZAboutDlg dialog

ZAboutDlg::ZAboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ZAboutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ZAboutDlg)
	//}}AFX_DATA_INIT
	if( m_BitmapButton.LoadBitmaps(
		_T("Image1Up"), _T("Image1Down"),_T("Image1Focus")) == FALSE )
	{
		AfxMessageBox( TEXT("Could not LoadBitmaps"),MB_OK|MB_ICONSTOP|MB_SETFOREGROUND|MB_TOPMOST);
		//debugf( TEXT("-->FAILED: LoadBitmaps") );
		ExitProcess(0);
	}

	//    :
	//m_dwSolidColor = RGB( 192, 192, 192 );
	//m_dwSolidColor = GetSysColor(COLOR_WINDOW);
}

//////////////////////////////////////////////////////////////////////////////
// ~ZAboutDlg

ZAboutDlg::~ZAboutDlg()
{
}

void ZAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ZAboutDlg)
	DDX_Control(pDX, IDC_ZABOUT_MSG1, m_stMsg1);
	DDX_Control(pDX, IDC_ZABOUT_MSG2, m_stMsg2);
	DDX_Control(pDX, IDC_ZABOUT_URL, m_HyperLink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(ZAboutDlg, CDialog)
	//{{AFX_MSG_MAP(ZAboutDlg)
	//ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_RBUTTONDOWN()
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// OnOK

void ZAboutDlg::OnOK()
{
	//CDialog::OnOK();
}
void ZAboutDlg::OnCancel() 
{
	//CDialog::OnCancel();
}
void ZAboutDlg::OnExit()
{
	EndDialog(0);	
}
void ZAboutDlg::OnClose() 
{
	OnExit();
}

//////////////////////////////////////////////////////////////////////////////
// OnInitDialog

BOOL ZAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//     .
	VERIFY(m_BitmapButton.SubclassDlgItem(IDC_EXIT, this));
	m_BitmapButton.SizeToContent();

	CString sFormat1;
	sFormat1.LoadString(IDS_ZABOUT_MSG1);
	if( sFormat1.IsEmpty() ) {
		SendMessage(WM_CLOSE, 0, 0);
		return FALSE;
	}

	CString sFormat2;
	sFormat2.LoadString(IDS_ZABOUT_MSG2);
	if( sFormat2.IsEmpty() ) {
		SendMessage(WM_CLOSE, 0, 0);
		return FALSE;
	}

	CString sAppName	=	AfxGetApp()->m_pszExeName;
	sAppName			+=	_T(".exe");
	CString sMsg1;
	sMsg1.Format(sFormat1, sAppName);
	m_stMsg1.SetWindowText( sMsg1 );

	CString sStamp;
	sStamp	=	(__TIMESTAMP__);
	CString sMsg2;
	sMsg2.Format(sFormat2, GVersion, sStamp);
	m_stMsg2.SetWindowText( sMsg2 );

	//   .
	//m_HyperLink.SetURL( _T( "mailto:Shvonder@yourcompany.com" ) );
	//m_HyperLink.SetURL( _T( "http://www.cultdeadcow.com" ) );
	//m_HyperLink.SubclassDlgItem( IDC_ABOUT_URL, this );
	m_HyperLink.SetURL(_T("mailto:shvond3r@hotmail.com"));

	if( m_point.x != 0 )
	{
		//  ,   ,
		//    .
		SetWindowPos(NULL, m_point.x, m_point.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
	}


	//
	// ----------------------------------------
	//     
	//  .
	// ----------------------------------------
	//
	CRect rectClient;
	GetClientRect(&rectClient);
	CSize sizeClient=rectClient.Size();

	//   ,    .
	CRect rectButton;
	m_BitmapButton.GetWindowRect(&rectButton);

	this->ScreenToClient(&rectButton);
	CSize sizeButton=rectButton.Size();
	
	int nX		= rectButton.left;	//  .
	int nY		= rectButton.top;	// .

	int nWidth	= sizeButton.cx;	//  .
	int nHeight = sizeButton.cy;	//  .

	//  .
	nX =( rectClient.Width() - nWidth ) / 2;

	// .
	//nY =( rectClient.Height() - nHeight ) / 2; 

	//m_BitmapButton.SetWindowPos(NULL, x, y, cx, cy, SWP_NOZORDER );
	m_BitmapButton.SetWindowPos(NULL, nX, nY, nWidth, nHeight, SWP_NOZORDER );

	return TRUE;
}

/*
void ZAboutDlg::OnPaint()
{
    CDC dcMem;
	CRect rect;
	GetClientRect(&rect);
	CPaintDC *pDC = new CPaintDC(this);
	pDC->SetBkMode(OPAQUE);
	//pDC->SetBkColor(m_dwSolidColor);
	pDC->FillSolidRect(&rect,m_dwSolidColor);
	CDialog::OnPaint();
}
*/

void ZAboutDlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CMenu menu;
	//CPoint point;
	GetCursorPos(&point);
	if( menu.CreatePopupMenu() )
	{
		TCHAR szText[] = _T("My favorite place...");
		UINT nFlags = MF_STRING;
		if( !menu.AppendMenu(nFlags, 1, szText) )
			return;
		
		UINT nIndex = menu.TrackPopupMenu(
			TPM_LEFTALIGN|TPM_RIGHTBUTTON|TPM_RETURNCMD,point.x,point.y,this);
		if( nIndex > 0 )
		{
			ShowWindow(SW_HIDE);
			
			// - - -  - - -
			//
			//   :  .
			//
			CFavoriteDlg fDlg;
			fDlg.DoModal();

			ShowWindow(SW_SHOW);
		}
	}

/*
	SendMessage(WM_CLOSE);
	return;

	static BOOL bShow = bShow ? FALSE : TRUE;

	if( bShow )
	{
		ShowWindow(SW_MAXIMIZE);
		Invalidate(FALSE);
		bShow = FALSE;
	}
	else
	{
		ShowWindow(SW_RESTORE);
		Invalidate(FALSE);
		bShow = TRUE;
	}
*/

}

/////////////////////////////////////////////////////////////////////////////
// <<eof>> ZAboutDlg.cpp
/////////////////////////////////////////////////////////////////////////////
